# Path to OSS ASN.1 Tools 

#OSS_ASN1_C_DIR = $(OSSINFO)/ossasn1/linux-glibc2.2/8.7.0
OSS_ASN1_C_DIR = /home/thorpe/shipments/ossasn1

ASN1=$(OSS_ASN1_C_DIR)/bin/asn1
ASN1FLAGS = -ber -root -h bcas.h -extern bcas -soed bcas.c

# Which archive ...
A = a

CC = cc          # must understands function prototypes
 
LFLAGS = -lm
#SOCKET_LFLAGS = -lsocket -lnsl   for Solaris
SOCKET_LFLAGS =  -lnsl
OSS_INC = $(OSS_ASN1_C_DIR)/include
OSS_LIB = $(OSS_ASN1_C_DIR)/lib
INCLUDES = -I. -I$(OSS_INC)
#CFLAGS = $(INCLUDES) -O -Xa    for Solaris
CFLAGS = $(INCLUDES) -O 

HFILES = $(OSS_INC)/asn1code.h $(OSS_INC)/asn1hdr.h $(OSS_INC)/ossber.h $(OSS_INC)/asn1util.h $(OSS_INC)/etype.h $(OSS_INC)/ossglobl.h

.SUFFIXES: .o .c
.c.o:
	$(CC) $(CFLAGS) -c $<


all: server client
	@echo ""
	@echo ""
	@echo ""
	@echo "You can now run 'server' then 'client' to" 
	@echo "test the socket memory manager.  The 'server' may need to be" 
	@echo "run from a privileged account in order to bind to a socket."

# Link the C-compiled output of the ASN.1 compiler with a simple
# demonstration application program and the appropriate runtime library.

server: bcas.o serverbf.o
	$(CC) -o $@ bcas.o serverbf.o $(OSS_LIB)/osssmgmt.o $(OSS_LIB)/libasn1code.$A $(LFLAGS)  $(SOCKET_LFLAGS)

client: bcas.o clientbf.o
	$(CC) -o $@ bcas.o clientbf.o $(OSS_LIB)/osssmgmt.o $(OSS_LIB)/libasn1code.$A $(LFLAGS)  $(SOCKET_LFLAGS)


# C-compile the output of the ASN.1 compiler

bcas.o: bcas.c $(HFILES)

# ASN.1-compile the input ASN.1 file

bcas.c bcas.h: bcas-38kb.asn
	$(ASN1) bcas-38kb.asn $(ASN1FLAGS)

# Clean up

clean:
	-rm -f bcas.o server client serverbf.o clientbf.o bcas.c bcas.h
